require 'extensions/all'
require_relative 'google_translator'
require_relative 'string_helpers'

class String

	@@translator = GoogleTranslator.new

	def language
		return @@translator.language self
	end

	# Translates strings, input language defaults to autodetect, output language to dutch
	#
	# @example Autodetect language of string and translate to dutch
	# 	string.translate
	#
	# @example Autodetect language of string and translate to french
	# 	string.translate( 'fr' )
	# 	string.translate( nil, 'fr' )
	#
	# @example string is in dutch, translate to french
	# 	string.translate( 'nl', 'de' )
	def translate arg1='auto', arg2=nil
		case arg1
		when nil
			input_language = 'auto'
		else
			input_language = (arg2 == nil) ? 'auto' : arg1
		end

		case arg2
		when nil
			output_language = (arg1 != nil) ? arg1 : 'nl'
		else
			output_language = arg2
		end

		output_language = (output_language == nil || output_language == 'auto') ? 'nl' : output_language

		(self == '') ? '' : @@translator.translate( self, input_language, output_language )
	end
end

# Quick test
=begin
	string = "Dit is een test (ook van de haakjes) 'en van de quotes'; einde bericht"
	puts string.translate
	puts string.translate( 'fr' )
	puts string.translate( 'en' )
	puts string.translate( nil, 'fr' )
 	puts string.translate( 'nl', 'de' )
=end
